"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const qwik = require("@builder.io/qwik");
const styles = "/* .test {\r\n  overflow-x: auto; \r\n} */\r\n\r\nbody {\r\n  display: flex;\r\n  flex-direction: column;\r\n  justify-content: center;\r\n  align-items: center;\r\n}\r\n\r\n.bg {\r\n  border: 1px solid #8c8c8c;\r\n  border-radius: 10px;\r\n  min-width: 250px;\r\n  height: 220px;\r\n  display: flex;\r\n  cursor: pointer;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: center;\r\n}\r\n\r\n.test::-webkit-scrollbar {\r\n  height: 8px;\r\n  left: -40px;\r\n}\r\n\r\n.test::-webkit-scrollbar-track {\r\n  background: #fafafa;\r\n  border-radius: 1rem;\r\n}\r\n\r\n.test::-webkit-scrollbar-thumb {\r\n  background: #e6e6e6;\r\n  border-radius: 3px;\r\n}\r\n\r\n.test {\r\n  padding-bottom: 20px;\r\n}\r\n";
const Slider = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  qwik.useStylesQrl(/* @__PURE__ */ qwik.inlinedQrl(styles, "Slider_component_useStyles_3HbwZrOmLJw"));
  const state = qwik.useStore({
    isDown: false,
    startX: 0,
    scrollLeft: 0,
    isMouseOver: false
  });
  const slider = qwik.useSignal();
  const onMouseDown = /* @__PURE__ */ qwik.inlinedQrl((e) => {
    const [slider2, state2] = qwik.useLexicalScope();
    state2.isDown = true;
    state2.startX = e.pageX - slider2.value.offsetLeft;
    state2.scrollLeft = slider2.value.scrollLeft;
  }, "Slider_component_onMouseDown_WN9guyVeHSM", [
    slider,
    state
  ]);
  const exit = /* @__PURE__ */ qwik.inlinedQrl(() => {
    const [state2] = qwik.useLexicalScope();
    state2.isDown = false;
    state2.isMouseOver = false;
  }, "Slider_component_exit_OOpUKBP0tL4", [
    state
  ]);
  const onMouseMove = /* @__PURE__ */ qwik.inlinedQrl((e) => {
    const [props2, slider2, state2] = qwik.useLexicalScope();
    if (!state2.isDown)
      return;
    const x = e.pageX - slider2.value.offsetLeft;
    const walk = (x - state2.startX) * (props2.scrollSpeed ?? 1);
    slider2.value.scrollLeft = state2.scrollLeft - walk;
  }, "Slider_component_onMouseMove_sqOFV6JnIxY", [
    props,
    slider,
    state
  ]);
  const handleMouseEnter = /* @__PURE__ */ qwik.inlinedQrl(() => {
    const [state2] = qwik.useLexicalScope();
    state2.isMouseOver = true;
  }, "Slider_component_handleMouseEnter_nED0ZS0dwY4", [
    state
  ]);
  qwik.useVisibleTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2, slider2, state2] = qwik.useLexicalScope();
    if ((props2.autoScroll ?? false) && !state2.isMouseOver) {
      const sliderElement = slider2.value;
      if (sliderElement) {
        const maxScrollLeft = sliderElement.scrollWidth - sliderElement.clientWidth;
        let scrollDirection = 1;
        const interval = setInterval(() => {
          if (!state2.isMouseOver) {
            if (scrollDirection === 1) {
              if (sliderElement.scrollLeft >= maxScrollLeft)
                scrollDirection = -1;
            } else if (sliderElement.scrollLeft <= 0)
              scrollDirection = 1;
            if (scrollDirection === 1)
              sliderElement.scrollLeft += 1;
            else
              sliderElement.scrollLeft -= 1;
          }
        }, props2.autoScrollSpeed ?? 15);
        return () => clearInterval(interval);
      }
    }
  }, "Slider_component_useVisibleTask_FVuPkVHsyn8", [
    props,
    slider,
    state
  ]));
  return /* @__PURE__ */ qwik._jsxQ("div", {
    ref: slider
  }, {
    class: qwik._fnSignal((p0) => `${p0.styleClass ?? ""}`, [
      props
    ], '`${p0.styleClass??""}`'),
    onMouseDown$: onMouseDown,
    onMouseEnter$: handleMouseEnter,
    onMouseLeave$: exit,
    onMouseMove$: onMouseMove,
    onMouseUp$: exit,
    "preventdefault:mousedown": true,
    style: qwik._fnSignal((p0) => ({
      overflowX: `${p0.showScrollbar ?? true ? "scroll" : "hidden"}`,
      display: "flex",
      gap: `${p0.gap ?? 15}px`,
      width: p0.width ?? ""
    }), [
      props
    ], '{overflowX:`${p0.showScrollbar??true?"scroll":"hidden"}`,display:"flex",gap:`${p0.gap??15}px`,width:p0.width??""}')
  }, /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "eq_0"), 1, "eq_1");
}, "Slider_component_wrpW1Kq03pA"));
exports.Slider = Slider;
